<script setup lang="ts">

</script>

<template>
  <ol>
    <li>Create two refs of type Task: newTask and createdTask</li>
    <li>Create a form, bind the inputs to the newTask ref</li>
    <li>
      Write a mutation to create a task, specify that it should return the id, description and
      priority of the created task
    </li>
    <li>
      Destructure useMutation into mutate and onDone:
      <code>const { mutate, onDone } = useMutation&lt;Task>(mutation)</code>
    </li>
    <li>
      Submit the form (prevent default) and call the mutate function with the <em>value</em> of the
      newTask ref
    </li>
    <li>
      onDone is a callback registration function, register a callback to display the created Task<br />
      <code>onDone(result => createdTask.value = result.data as Task)</code>
    </li>
    <li>
      Display newTask and CreatedTask between PRE tags
    </li>
  </ol>
<!--  <form @submit.prevent="createTask">-->
<!--    <div>-->
<!--      <label>Description <input type="text" v-model="newTask.description" /></label>-->
<!--    </div>-->
<!--    <div>-->
<!--      <label-->
<!--        >Priority-->
<!--        <select v-model="newTask.priority">-->
<!--          <option :value="PriorityEnum.HIGH">High</option>-->
<!--          <option :value="PriorityEnum.MEDIUM">Medium</option>-->
<!--          <option :value="PriorityEnum.LOW">Low</option>-->
<!--        </select></label-->
<!--      >-->
<!--    </div>-->
<!--    <button type="submit">Create task</button>-->
<!--  </form>-->
  <pre>
    <!-- ************************************************************  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- *              PLACE THE NEWTASK HERE!                     *  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- ************************************************************  -->
  </pre>
  <pre>
    <!-- ************************************************************  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- *              PLACE THE CREATEDTASK!                      *  -->
    <!-- *                                                          *  -->
    <!-- *                                                          *  -->
    <!-- ************************************************************  -->
  </pre></template>

<style scoped>
form {
  margin-block: 2rem;
  padding: 2rem;
  border: 1px solid;
  button {
    margin-top: 2rem;
  }
}
</style>
